#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Anstelle der Studentenstruktur wird jetzt ein Zeiger auf */
/* diese Struktur an die Insert-Funktion uebergeben. Problem */ 
/* ist allerdings, dass im Hauptprogramm nur einmal Platz fuer */ 
/* die Strukturvariable studis bereitgestellt wurde. D.h. beim */
/* Einlesen eines neuen Studenten wird dieser Speicherplatz */
/* jedesmal neu ueberschrieben. Da nun aber nur der Zeiger auf */
/* diesen Speicherplatz als Parameter uebergeben wird, zeigen alle */
/* Zeiger auf den Inhalt, der zuletzt an diese Speicherstelle */
/* geschrieben wurde (also auf den letzten Datensatz, der */
/* eingelesen wurde). */

struct studenten {
	int matrnr;
	char name[100];
};

struct tree {
	void *element;
	struct tree *left;
	struct tree *right;
};

void insert(struct tree * *t, struct studenten *s) {
	if ((*t) == NULL) {
		(*t) = (struct tree*)calloc(sizeof(struct tree), 1);
		(struct studenten *)((*t)->element) = s;
		(*t)->left = NULL;
		(*t)->right = NULL;
	}
	else if ((*s).matrnr <= ((struct studenten *) ((*t)->element) )->matrnr) {
		insert(&((*t)->left), s);
	}
	else {
		insert(&((*t)->right), s);
	}
}

void print(struct tree *t) {
	if (t != NULL) {
		print(t->left);
        printf("%d:", ((struct studenten *)t->element)->matrnr);
        printf("%s", ((struct studenten *)t->element)->name);
		print(t->right);
	}
}

int main() {

	struct tree *root = NULL;

	struct studenten studis;

    char *token;
    char buf[30];
    FILE *fp = NULL;
	int counter = 0;

    if (!(fp = fopen("studis.txt", "r"))) {
        fprintf(stderr, "ERROR: FILE OPEN");
        return 1;
    }

    while (fgets(buf, 30, fp) > 0) {
        token = strtok(buf, ":");
        sscanf(token, "%d", &(studis.matrnr));
        token = strtok(NULL, ":");
        strcpy(studis.name, token);
        insert(&root, &studis);
		counter++;
    }

    printf("Nach Matrikelnummer sortiert:\n");

	print(root);

	return 0;

}
