#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Ebenso soll die Print-Funktion unabhaengig von der */
/* Studentenstruktur sein. Deshalb wird neben dem */
/* Typ CmpFkt noch ein weiterer Typ PrintFkt eingefuehrt. */

typedef int(*CmpFkt)(const void *, const void *);
typedef void(*PrintFkt)(const void *);

struct studenten {
	int matrnr;
	char name[100];
};

struct tree {
	void *element;
	struct tree *left;
	struct tree *right;
};

int cmpmatrnr(const void *s1, const void *s2) {
    const struct studenten *t1 = s1;
    const struct studenten *t2 = s2;
    return t1->matrnr - t2->matrnr;
}

int cmpname(const void *s1, const void *s2) {
    const struct studenten *t1 = s1;
    const struct studenten *t2 = s2;

    char *n1 = strrchr(t1->name, ' ');
    char *n2 = strrchr(t2->name, ' ');

    int tmp = strcmp(n1, n2);

    if (tmp != 0)
        return tmp;
    return strcmp(t1->name, t2->name);
}

void insert(struct tree * *t, void *s, CmpFkt cmp) {
	if ((*t) == NULL) {
		(*t) = (struct tree*)calloc(sizeof(struct tree), 1);
		(*t)->element = s;
		(*t)->left = NULL;
		(*t)->right = NULL;
	}
    else if ( (*cmp)(s, (*t)->element) <= 0 ) {
        insert(&((*t)->left), s, cmp);
	}
	else {
		insert(&((*t)->right), s, cmp);
	}
}

void printmatrnr(const void *s) {
    printf("%d\n", ((struct studenten *)s)->matrnr);
}

void printname(const void *s) {
    printf("%s", ((struct studenten *)s)->name);
}

void printstudis(const void *s) {
    printf("%d:%s", ((struct studenten *)s)->matrnr,
        ((struct studenten *)s)->name);
}

void print(struct tree *t, PrintFkt pr) {
	if (t != NULL) {
		print(t->left, pr);
		(*pr)(t->element);
		print(t->right, pr);
	}
}

int main() {

	struct tree *root = NULL;

	struct studenten studis;
	struct studenten *p;

    char *token;
    char buf[30];
    FILE *fp = NULL;

    if (!(fp = fopen("studis.txt", "r"))) {
        fprintf(stderr, "ERROR: FILE OPEN");
        return 1;
    }

    while (fgets(buf, 30, fp) > 0) {
        token = strtok(buf, ":");
        sscanf(token, "%d", &(studis.matrnr));
        token = strtok(NULL, ":");
        strcpy(studis.name, token);
		p = calloc(1, sizeof(struct studenten));
		*p = studis;
        insert(&root, p, cmpmatrnr);
    }

    printf("Nach Matrikelnummer sortiert:\n");

	print(root, printmatrnr);
	print(root, printname);
	print(root, printstudis);

	return 0;

}
